class Fdcloud < Fdarchivo
  require 'google/cloud'
  attr_accessor :file
  #TODO: Afterdo gem check_config?
  def initialize(file = nil, tmp: false)
    check_config
    if tmp
      @file = @config.tmp_bucket.file(file) if file
    else
      @file = @config.cloud_bucket.file(file) if file
    end
    # unless file
    #   raise "File not found #{file}.\n Check your buckets."
    # end
  end

  # Fixme: cambio de bucket
  def change_bucket(bucket)
    self.class.superclass.configure.cloud_bucket = bucket
    @config = check_config
  end

  def upload(filepath, archivo)
    self.file = @config.cloud_bucket.create_file(filepath, archivo.path)
    self.file.acl.public!
    # Comprobar el archivo local y borrarlo una vez subido
    if File.exist?(filepath)
      File.delete(filepath)
    end
    self
  end

  def tmp_upload(filepath, archivo)
    if @config.tmp_bucket.nil?
      raise 'Es necesario establecer tmp_bucket en el iniciador de rails.'
    end
    self.file = @config.tmp_bucket.create_file(filepath, archivo.path)
    self.file.acl.public!
    self
  end

  def move_tmp(archivo)
    files = copy(archivo)
    files[0].delete
    self.file
  end
  def copy(archivo)
    files = [self.file]
    files[1] = files[0].copy(@config.cloud_bucket, archivo.path)
    files[1].acl.public!
    self.file = files[1]
    files
  end

  def delete
    self.file.try(:delete)
  end

  def url
    self.file.public_url
  end

  def check_config
    @config = self.class.superclass.configuration if self.class.superclass.configuration.check
  end
end
